#include "B4RDefines.h"

namespace B4R {
	void B4RRCSwitch::Initialize() {
		rcs = new (backend) RCSwitch();
	}
	void B4RRCSwitch::looper(void* b) {
		B4RRCSwitch* me = (B4RRCSwitch*)b;
		if (me->rcs->available()) {
			me->DataAvailableSub();
		}
	}
	void B4RRCSwitch::EnableReceive(SubVoidVoid DataAvailableSub, int ReceiverPin) {
		this->DataAvailableSub = DataAvailableSub;
		FunctionUnion fu;
		fu.PollerFunction = looper;
		pnode.functionUnion = fu;
		pnode.tag = this;
		if (pnode.next == NULL)
			pollers.add(&pnode);
		rcs->enableReceive(ReceiverPin);
	}
	
	void B4RRCSwitch::ResetAvailable() {
		rcs->resetAvailable();
	}
	
	ULong B4RRCSwitch::getReceivedCode() {
		return rcs->getReceivedValue();
	};
		
	UInt B4RRCSwitch::getReceivedBitLength() {
		return rcs->getReceivedBitlength();
	};
	
	UInt B4RRCSwitch::getReceivedDelay() {
		return rcs->getReceivedDelay();
	};
		
	UInt B4RRCSwitch::getReceivedProtocol() {
		return rcs->getReceivedProtocol();
	};

	void B4RRCSwitch::EnableTransmit(int TransmitterPin) {
		rcs->enableTransmit(TransmitterPin);
	};

	void B4RRCSwitch::Send(ULong Code, UInt BitLength) {
		rcs->send(Code,BitLength);
	};

	void B4RRCSwitch::setProtocol(int Protocol) {
		rcs->setProtocol(Protocol);
	};
 			
	void B4RRCSwitch::setPulseLength(int PulseLength) {
		rcs->setPulseLength(PulseLength);
	};
			
	void B4RRCSwitch::setRepeatTransmit(int RepeatTransmit) {
		int repeat = RepeatTransmit;
		rcs->setRepeatTransmit(RepeatTransmit);
	};

}
